#ifndef AX_ALD_H__
#define AX_ALD_H__
/*-------------------------------------------------------------------------*/

/*
	
	Alice Soft archive (*.ALD) (C)Alice Soft
	Susie Plug-in

*/

/*-------------------------------------------------------------------------*/

#include "SpiBase.h"
	
/* wb_̍\ (*.ALD)
 * wb_ *
	uint24 data1;				* ??? *
	uint24 position[fileCount];	* t@C̈ʒu *

	iԖڂ̃t@CʒúA(2 + 3*i) 4 byte 0xFFFFFF00&lɂȂ

 * t@C *
	uint32 sizeOfThis;		* wb_TCY *
	uint32 fileSize;		* t@CTCY *
	uint16 reserved1;
	uint16 reserved2;
 	char filename[sizeOfThis - 16];		* t@C(K '\0'ŏI[H) *

 * tb^ *
	uint32 id;			// 0x00014C4E
	uint32 data2;		// 0x00000010
	uint8 data3;		// 0x00
	uint24 fileCouont;	// t@C
	uint32 data4;		// 0x00000000

**/

/*-------------------------------------------------------------------------*/

class SpiALD : public SpiBase
{
private:
	enum _const
	{
		ALD_MAX_SIZE = 200 + 16,
		ID_ALD = 0x00444C41,
		ID_FOOTER	= 0x00014C4E	// NL, 0x0001
	};

#pragma pack(1)
	struct ALDInfo
	{
		DWORD sizeOfThis;
		DWORD fileSize;
		DWORD reserved1;
		DWORD reserved2;
//		char filename[sizeOfThis - 16];
	};
#pragma pack()

public:
	// Ήt@CmF
	static int IsSupported(BYTE* data, LPCSTR extension)
	{
		// 2KBAgq炢@ȂEEE
		return !lstrcmpi(extension, "ALD") || (*(ULONG*)&data[2] != 0);
	}

	// t@C̃Zbg
	ULONG SetFileinfo(fileInfo& info, AutoFile& file, ULONG position)
	{
		ALDInfo aldInfo;
		if ((file.Seek(position, FILE_BEGIN) == INVALID_SET_FILE_POINTER) || !file.Read(&aldInfo, 16))
		{
			return 0;
		}
		if (aldInfo.sizeOfThis < ALD_MAX_SIZE)
		{
			if (!file.Read(&info.filename, aldInfo.sizeOfThis - 16))
			{
				return 0;
			}
			info.filename[aldInfo.sizeOfThis - 17] = '\0';
		}
		else
		{
			if (!file.Read(&info.filename, ALD_MAX_SIZE - 16))
			{
				return 0;
			}
			info.filename[ALD_MAX_SIZE - 17] = '\0';
			file.Seek(aldInfo.sizeOfThis - ALD_MAX_SIZE);
		}
		*reinterpret_cast<DWORD*>(info.method)	= ID_ALD;
		info.path[0]	= '\0';
		info.position	= position;
		info.filesize	= aldInfo.fileSize;
		info.compsize	= aldInfo.fileSize;
		return aldInfo.sizeOfThis;
	}

	// src memory

	/* ͎͂ȂBftHg̎ɔC */

	// src File
/*-------------------------------------------------------------------------*/
/* [t@C]A[JCûׂẴt@C̏擾 */
	int GetArchiveInfo(LPSTR src, DWORD offset, HLOCAL *lphInf)
	{
		SpiTrace("SpiALD::GetArchiveInfo\n");

		// t@CJ
		AutoFile srcFile;
		DWORD read;
		DWORD buffer[4];
		if (srcFile.Open(src) == INVALID_HANDLE_VALUE)
			return SPI_FILE_READ_ERROR;
		if (srcFile.Seek(-16, FILE_END) == INVALID_SET_FILE_POINTER || !srcFile.Read(buffer, 16, &read))
			return SPI_FILE_READ_ERROR;
		if (buffer[0] != ID_FOOTER)
			return SPI_NOT_SUPPORT;
		DWORD fileCount	= buffer[2] >> 8;

		// m
		LocalHeap lhInfo;
		fileInfo* pInfo	= reinterpret_cast<fileInfo*>(lhInfo.Alloc(fileCount * sizeof(fileInfo) + 1));
		if (pInfo == NULL)
			return SPI_NO_MEMORY;

		// t@C̎擾
		for (DWORD i = 0;i < fileCount;i++)
		{
			DWORD position;
			if (srcFile.Seek(2 + 3 * i, FILE_BEGIN) == INVALID_SET_FILE_POINTER || !srcFile.Read(&position, 4, &read))
				return SPI_FILE_READ_ERROR;

			position	&= 0xFFFFFF00;
			if (SetFileinfo(pInfo[i], srcFile, position) == 0)
				return SPI_FILE_READ_ERROR;
		}
		*lphInf	= lhInfo.Detach();
		return SPI_ALL_RIGHT;
	}

/*-------------------------------------------------------------------------*/
/* [t@C]A[JCu̎w肵t@C̏擾 */
	int GetFileInfo(LPSTR src, DWORD offset, LPSTR filename, bool bCompareNoCase, fileInfo *lpInfo)
	{
		SpiTrace("SpiALD::GetFileInfo\n");

		// t@CJ
		AutoFile srcFile;
		DWORD read;
		DWORD buffer[4];
		if (srcFile.Open(src) == INVALID_HANDLE_VALUE)
			return SPI_FILE_READ_ERROR;
		if (srcFile.Seek(-16, FILE_END) == INVALID_SET_FILE_POINTER || !srcFile.Read(buffer, 16, &read))
			return SPI_FILE_READ_ERROR;
		if (buffer[0] != ID_FOOTER)
			return SPI_NOT_SUPPORT;
		DWORD fileCount	= buffer[2] >> 8;

		// 啶E̋
		int (WINAPI *cmpFunc)(LPCSTR, LPCSTR)	= lstrcmpi;	// 啶E𓯈ꎋ
		if (!bCompareNoCase)
			cmpFunc = lstrcmp;	// 啶E

		// t@C̎擾
		fileInfo info	= {0};
		for (DWORD i = 0;i < fileCount;i++)
		{
			DWORD position;
			if (srcFile.Seek(2 + 3 * i, FILE_BEGIN) == INVALID_SET_FILE_POINTER || !srcFile.Read(&position, 4, &read))
				return SPI_FILE_READ_ERROR;
			position	&= 0xFFFFFF00;

			if (SetFileinfo(info, srcFile, position) == 0)
				return SPI_FILE_READ_ERROR;

			if (!cmpFunc(info.filename, filename))
			{
				*lpInfo	= info;
				return SPI_ALL_RIGHT;
			}
		}
		return SPI_NOT_SUPPORT;
	}

/*-------------------------------------------------------------------------*/
/* [t@C]A[JCũt@C𒊏o */
	int GetFile(LPSTR src, DWORD offset, LPSTR dest, bool bDestMemory, SPI_CALLBACK prgressCallback, long lData)
	{
		SpiTrace("SpiALD::GetFile\n");

		// t@CJ
		AutoFile srcFile;
		if (srcFile.Open(src) == INVALID_HANDLE_VALUE)
			return SPI_FILE_READ_ERROR;

		// t@C̎擾
		fileInfo info;
		if (SetFileinfo(info, srcFile, offset) == 0)
		{
			return SPI_FILE_READ_ERROR;
		}

		// ̊m
		LocalHeap lhImage;
		void* pImage	= lhImage.Alloc(info.filesize ? info.filesize : 4, LMEM_MOVEABLE);
		if (pImage == NULL)
			return SPI_NO_MEMORY;

		// t@CC[W̓Ǎ
		DWORD read;
		if (!srcFile.Read(pImage, info.filesize, &read) || (read != info.filesize))
		{
			return SPI_FILE_READ_ERROR;
		}

		if (bDestMemory)
		{
			/* o */
			HLOCAL *phMem = reinterpret_cast<HLOCAL*>(dest);
			*phMem = lhImage.Detach();
		} else {
			/* t@Co */
			char destPath[MAX_PATH];
			lstrcpy(destPath, dest);
			lstrcat(destPath, "\\");
			lstrcat(destPath, info.filename);
			AutoFile destFile;
			if (destFile.Open(destPath, false) == INVALID_HANDLE_VALUE)
				return SPI_FILE_WRITE_ERROR;

			DWORD written;
			if (!destFile.Write(pImage, info.filesize, &written))
				return SPI_FILE_WRITE_ERROR;
		}
		return SPI_ALL_RIGHT;
	}
};

#endif // AX_ALD_H__
