//-------------------------------------------------------------------------
/*

	Susie Plug-in API

	last update: 2006/12/15:

*/
//-------------------------------------------------------------------------
#include <windows.h>
#include <time.h>
#include "spi_api.h"
#include "SpiManager.h"

static const int HEADER_SIZE = 2048;

/*------------------------------------------------------------------------*/
/* DLL entry */
BOOL WINAPI DllMain(HINSTANCE hinst, DWORD dwReason, LPVOID lpReserved)
{
	SpiTrace("DllMain: %d\n", dwReason);
#ifdef	SPI_CONFIG
	switch(dwReason)
	{
	case DLL_PROCESS_ATTACH:
		_config.m_hInst	= hinst;
		break;
	case DLL_THREAD_ATTACH:
//			break;
	case DLL_THREAD_DETACH:
//			break;
	case DLL_PROCESS_DETACH:
		break;
	}
#else
	hinst;
	dwReason;
#endif
	lpReserved;
	return TRUE;
}

/*-------------------------------------------------------------------------*/
// Susie plug-in Common function

// vOC̎擾
int PASCAL GetPluginInfo(int infono, LPSTR buf, int buflen)
{
	SpiTrace("GetPluginInfo: %d\n", infono);

	const int maxInfo	= sizeof(SpiManager::m_pluginInfo) / sizeof(SpiManager::m_pluginInfo[0]);
	SpiAssert(maxInfo > 2);

	// strlenȂǂ̎dlɍ킹Anull܂܂ȂԂ
	int length	= 0;
	if (0 <= infono && infono < maxInfo)
	{
		LPCSTR info	= SpiManager::m_pluginInfo[infono];
		length = lstrlen(info);
		if (length >= buflen)
			length = buflen - 1;
		lstrcpyn(buf, info, length + 1);
	}
	return length;
}

/*-------------------------------------------------------------------------*/
// Ήt@CmF
int PASCAL IsSupported(LPSTR filename, DWORD dw)
{
	SpiTrace("IsSupported\n");

	BYTE buffer[HEADER_SIZE];
	union {
		DWORD dwData;
		BYTE* pByte;
		HANDLE hFile;
	} param	= { dw };	// ʂɃLXgƁAVCwarningoČȂ̂

	/*
		2oCg0ȂAt@Cnh
		0ȂAf[^ւ̃|C^
    */
	if ((dw & 0xFFFF0000) == 0)
	{
		/* t@Cnh */
    	DWORD readBytes;
		if (!ReadFile(param.hFile, buffer, HEADER_SIZE, &readBytes, NULL))
            return 0;	/* ǂݍ݃G[ */
        param.pByte = buffer;
    }

    /* Ήt@CmF */
	return SpiManager::IsSupported(filename, param.pByte);
}

/*-------------------------------------------------------------------------*/
#ifdef	SPI_CONFIG
// ݒ_CAO
/*
	ȂȂADEFt@CɋLqȂƁB
*/
int FAR PASCAL ConfigurationDlg(HWND parent,int fnc)
{
	SpiTrace("ConfigurationDlg: %d\n", fnc);

	switch (fnc)
	{
	case SPI_CONFIG_ABOUT:
		MessageBox(parent, SpiManager::m_pluginInfo[1], "o[W", MB_OK);
		break;
	case SPI_CONFIG_SETTING:
		{
			SpiConfigDlg dlg;
			dlg.DoModal(_config.m_hInst, parent);
		}
		break;
	default:
		return SPI_NO_FUNCTION;
	}
	return SPI_ALL_RIGHT;
}

#endif	// SPI_CONFIG



/*-------------------------------------------------------------------------*/
/* '00IN' function */
#ifndef	SPI_00AM

// 摜̎擾
int PASCAL GetPictureInfo(LPSTR buf, long len, unsigned int flag, PictureInfo *lpInfo)
{
	SpiTrace("GetPictureInfo\n");

	/*
		PNĜ悤Ƀtb^ɏeLXgtH[}bg
		ł́ASẴC[WǂݍޕKvB
		AقƂǂ̏ꍇ́A擪2KBΏ\
	*/
	BYTE* src;
	long length	= len;
	HANDLE hFile;
#ifndef	GET_PICTURE_INFO_READ_ALL
	BYTE headerBuf[HEADER_SIZE];
#endif
	LPSTR fileName	= NULL;
	if ((flag & SPI_SRC_MEMORY) == SPI_SRC_MEMORY)
	{
		// buf̓f[^ւ̃|C^
		src = reinterpret_cast<BYTE*>(buf);
	} else {
		// buf̓t@C
		hFile = CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE)
			return SPI_FILE_READ_ERROR;

#ifdef	GET_PICTURE_INFO_READ_ALL
		length = ::GetFileSize(hFile, NULL);
		if (length <= len)	// TCY0̓}bsO֎~
		{
			CloseHandle(hFile);
			return SPI_NOT_SUPPORT;
		}

		// t@CɃ}bsO
		HANDLE hMap	= CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);
		src	= reinterpret_cast<BYTE*>(MapViewOfFile(hMap, FILE_MAP_READ, 0, 0, 0));
		CloseHandle(hMap);
		if (src == NULL)
		{
			CloseHandle(hFile);
			return SPI_MEMORY_ERROR;
		}
		src	= &src[len];
		length -= len;
#else
		// 擪2KB̂ݓǂݍ
		DWORD ReadBytes;
		BOOL bOk	= ReadFile(hFile, headerBuf, HEADER_SIZE, &ReadBytes, NULL);
		CloseHandle(hFile);
		if (!bOk)
			return SPI_FILE_READ_ERROR;
		src	= headerBuf;
		length	= static_cast<long>(ReadBytes);
#endif	// GET_PICTURE_INFO_READ_ALL
		fileName	= buf;
	}
	// ΉvOČĂяo
	SpiManager manager;
	SpiBase* spi	= manager.QuerySpi(fileName, src);
	int nResult	= SPI_NOT_SUPPORT;
	if (spi != NULL)
		nResult	= spi->GetPictureInfo(src, length, lpInfo);

#ifdef	GET_PICTURE_INFO_READ_ALL
	// t@C
	if ((flag & SPI_SRC_MEMORY) == 0)
	{
		UnmapViewOfFile(src - len);			
		CloseHandle(hFile);
	}
#endif
	return nResult;
}

/*-------------------------------------------------------------------------*/
// 摜f[^̎擾
int PASCAL GetPicture(LPSTR buf, long len, unsigned int flag, HANDLE *pHBInfo, HANDLE *pHBm,
						SPI_CALLBACK lpPrgressCallback, long lData)
{
	SpiTrace("GetPicture\n");

	BYTE* src;
	long length	= len;
	HANDLE hFile	= INVALID_HANDLE_VALUE;
	LPSTR fileName	= NULL;
	if ((flag & SPI_SRC_MEMORY) == SPI_SRC_MEMORY)
	{
		// buf̓f[^ւ̃|C^
		src = reinterpret_cast<BYTE*>(buf);
	} else {
		// buf̓t@C
		hFile = CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE)
			return SPI_FILE_READ_ERROR;

		length = ::GetFileSize(hFile, NULL);
		if (length <= len)	// TCY0̓}bsO֎~
		{
			CloseHandle(hFile);
			return SPI_NOT_SUPPORT;
		}

		// t@CɃ}bsO
		HANDLE hMap	= CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);
		src	= reinterpret_cast<BYTE*>(MapViewOfFile(hMap, FILE_MAP_READ, 0, 0, 0));
		CloseHandle(hMap);
		if (src == NULL)
		{
			CloseHandle(hFile);
			return SPI_MEMORY_ERROR;
		}
		fileName	= buf;
		src	= &src[len];
		length -= len;
	}
	// ΉvOČĂяo
	SpiManager manager;
	SpiBase* spi	= manager.QuerySpi(fileName, src);
	int nResult	= SPI_NOT_SUPPORT;
	if (spi != NULL)
		nResult	= spi->GetPicture(src, length, pHBInfo, pHBm, lpPrgressCallback, lData);

	// t@C
	if (hFile != INVALID_HANDLE_VALUE)
	{
		UnmapViewOfFile(src - len);			
		CloseHandle(hFile);
	}
	return nResult;
}

/*-------------------------------------------------------------------------*/
// vr[
/*
	ȂꍇADEFt@Cɂ͋LqăGNX|[gA
	SPI_NO_FUNCTIONԂ
*/
int PASCAL GetPreview(LPSTR buf, long len, unsigned int flag, HANDLE *pHBInfo, HANDLE *pHBm,
						SPI_CALLBACK lpPrgressCallback, long lData)
{
	SpiTrace("GetPreview\n");

#ifndef SPI_GET_PREVIEW
	buf;len;flag;pHBInfo;pHBm;lpPrgressCallback;lData;
	return SPI_NO_FUNCTION;
#else
	BYTE* src;
	long length	= len;
	HANDLE hFile	= INVALID_HANDLE_VALUE;
	LPSTR fileName	= NULL;
	if ((flag & SPI_SRC_MEMORY) == SPI_SRC_MEMORY)
	{
		// buf̓f[^ւ̃|C^
		src = reinterpret_cast<BYTE*>(buf);
	} else {
		// buf̓t@C
		hFile = CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE)
			return SPI_FILE_READ_ERROR;

		length = ::GetFileSize(hFile, NULL);
		if (length <= len)	// TCY0̓}bsO֎~
		{
			CloseHandle(hFile);
			return SPI_NOT_SUPPORT;
		}

		// t@CɃ}bsO
		HANDLE hMap	= CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);
		src	= reinterpret_cast<BYTE*>(MapViewOfFile(hMap, FILE_MAP_READ, 0, 0, 0));
		CloseHandle(hMap);
		if (src == NULL)
		{
			CloseHandle(hFile);
			return SPI_MEMORY_ERROR;
		}
		fileName	= buf;
		src	= &src[len];
		length -= len;
	}
	// ΉvOČĂяo
	SpiManager manager;
	SpiBase* spi	= manager.QuerySpi(fileName, src);
	int nResult	= SPI_NOT_SUPPORT;
	if (spi != NULL)
		nResult	= spi->GetPreview(src, length, pHBInfo, pHBm, lpPrgressCallback, lData);

	// t@C
	if (hFile != INVALID_HANDLE_VALUE)
	{
		UnmapViewOfFile(src - len);			
		CloseHandle(hFile);
	}
	return nResult;

#endif	// SPI_GET_PREVIEW
}

#else	// SPI_00AM
/*-------------------------------------------------------------------------*/
/* '00AM' function */

// A[JCu̎擾
int PASCAL GetArchiveInfo(LPSTR buf, long len, unsigned int flag, HLOCAL *lphInf)
{
	SpiTrace("GetArchiveInfo\n");

	/*
		A[JCu̓t@CTCY傫ꍇB
		āAt@C}bsOȂB
	*/
	SpiManager manager;
	int nResult	= SPI_NOT_SUPPORT;
	if ((flag & SPI_SRC_MEMORY) == SPI_SRC_MEMORY)
	{
		// buf̓f[^ւ̃|C^
		SpiBase* spi	= manager.QuerySpi(NULL, reinterpret_cast<BYTE*>(buf));
		if (spi != NULL)
			nResult	= spi->GetArchiveInfoMem(buf, len, lphInf);
	} else {
		// buf̓t@C
		HANDLE hFile	= CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE)
			return SPI_FILE_READ_ERROR;

		BYTE headerBuf[HEADER_SIZE];
		DWORD ReadBytes;
		BOOL bOk	= ReadFile(hFile, headerBuf, HEADER_SIZE, &ReadBytes, NULL);
		CloseHandle(hFile);
		if (!bOk)
			return SPI_FILE_READ_ERROR;
		SpiBase* spi	= manager.QuerySpi(buf, headerBuf);
		if (spi != NULL)
			nResult	= spi->GetArchiveInfo(buf, len, lphInf);
	}
	return nResult;
}

/*-------------------------------------------------------------------------*/
// t@C̎擾
/*
	Susieł͌Ă΂Ȃ
	VixȂǂł͌Ă΂̂ŁÂ
*/

int PASCAL GetFileInfo(LPSTR buf, long len, LPSTR filename, unsigned int flag, fileInfo *lpInfo)
{
	SpiTrace("GetFileInfo\n");

	SpiManager manager;
	int nResult	= SPI_NOT_SUPPORT;
	bool bNoCase	= (flag & SPI_IGNORECASE) == SPI_IGNORECASE;
	if ((flag & SPI_SRC_MEMORY) == SPI_SRC_MEMORY)
	{
		// buf̓f[^ւ̃|C^
		SpiBase* spi	= manager.QuerySpi(NULL, reinterpret_cast<BYTE*>(buf));
		if (spi != NULL)
			nResult	= spi->GetFileInfoMem(buf, len, filename, bNoCase, lpInfo);
	} else {
		// buf̓t@C
		HANDLE hFile	= CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE)
			return SPI_FILE_READ_ERROR;

		BYTE headerBuf[HEADER_SIZE];
		DWORD ReadBytes;
		BOOL bOk	= ReadFile(hFile, headerBuf, HEADER_SIZE, &ReadBytes, NULL);
		CloseHandle(hFile);
		if (!bOk)
			return SPI_FILE_READ_ERROR;
		SpiBase* spi	= manager.QuerySpi(buf, headerBuf);
		if (spi != NULL)
			nResult	= spi->GetFileInfo(buf, len, filename, bNoCase, lpInfo);
	}
	return nResult;
}

/*-------------------------------------------------------------------------*/
// t@CC[W̎擾/o
int PASCAL GetFile(LPSTR src, long len, LPSTR dest, unsigned int flag, SPI_CALLBACK prgressCallback, long lData)
{
	SpiTrace("GetFile\n");

	SpiManager manager;
	int nResult	= SPI_NOT_SUPPORT;
	bool bDestMemory	= (flag & SPI_DEST_MEMORY) == SPI_DEST_MEMORY;
	if ((flag & SPI_SRC_MEMORY) == SPI_SRC_MEMORY)
	{
		// buf̓f[^ւ̃|C^
		SpiBase* spi	= manager.QuerySpi(NULL, reinterpret_cast<BYTE*>(src));
		if (spi != NULL)
			nResult	= spi->GetFileMem(src, len, dest, bDestMemory, prgressCallback, lData);
	} else {
		// buf̓t@C
		HANDLE hFile	= CreateFile(src, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE)
			return SPI_FILE_READ_ERROR;

		BYTE headerBuf[HEADER_SIZE];
		DWORD ReadBytes;
		BOOL bOk	= ReadFile(hFile, headerBuf, HEADER_SIZE, &ReadBytes, NULL);
		CloseHandle(hFile);
		if (!bOk)
			return SPI_FILE_READ_ERROR;
		SpiBase* spi	= manager.QuerySpi(src, headerBuf);
		if (spi != NULL)
			nResult	= spi->GetFile(src, len, dest, bDestMemory, prgressCallback, lData);
	}
	return nResult;
}

#endif	// SPI_00AM


