#pragma once


//////////////////////////////////////////////////////////////
// Dialog base class like ATL
template <class T>
class CDialogImplBase
{
public:
//	enum ResourceID { IDD = 0 };

	HWND m_hWnd;

	CDialogImplBase()
		: m_hWnd(NULL)
	{
	}

	// modal
	INT_PTR DoModal(HINSTANCE hInstance, HWND hWnd)
	{
		return DialogBoxParam(hInstance, MAKEINTRESOURCE(T::IDD), hWnd, InternalProc, (LPARAM)this);
	}

	// modeless
	HWND Create(HINSTANCE hInstance, HWND hWnd)
	{
		return CreateDialogParam(hInstance, MAKEINTRESOURCE(T::IDD), hWnd, InternalProc, (LPARAM)this);
	}

	// _CAOvV[W
	static INT_PTR CALLBACK InternalProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
	{
/*
	WM_INITDIALOGŁASetWindowLongPtr()this|C^User dataɃZbgB
	Ȍ́AGetWindowLongPtr()this|C^擾
*/
		T* pT;
		if (uMsg == WM_INITDIALOG)
		{
			pT	= (T*)lParam;
			pT->m_hWnd	= hwndDlg;
			::SetWindowLongPtr(hwndDlg, GWLP_USERDATA, static_cast<long>(lParam));
		}
		else
		{
			pT	= (T*)(LONG_PTR)::GetWindowLongPtr(hwndDlg, GWLP_USERDATA);
		}
		if (pT == NULL)
			return 1;
		return pT->DialogProc(hwndDlg, uMsg, wParam, lParam);
	}

	LRESULT DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
	{
#ifdef	_DEBUG
		::OutputDebugString("CDialogImplBase::DialogProc() must be override!\n");
		::DebugBreak();
#endif
		return 0;
	}
};
