#ifndef SPI_CONFIG
#define SPI_CONFIG

#include "resource.h"
#include "DialogBase.h"


// ݒf[^
class SpiConfig
{
private:
	HBRUSH m_hBgBrush;
	COLORREF m_tmpBgColor;

public:
	HINSTANCE m_hInst;
	bool m_bAlphaBrend;
	RGBQUAD m_rgb;

	SpiConfig()
		: m_hBgBrush(NULL),
		m_hInst(NULL),
		m_bAlphaBrend(true)
	{
		m_rgb	= CRgb(0, 0xFF, 0);

		// LoadLibrary()/LoadLibraryEx()Ń[hꍇ̂݁A
		// DllMain()ŃWXgR/W\
		UpdateRegKey();
	}

	// ݒf[^̎擾
	static SpiConfig& GetConfig()
	{
		static SpiConfig config;
		return config;
	}

	// WXgR/W
	void UpdateRegKey(bool bRead = true)
	{
	// WXgGg
		static const char spiDirKey[]	= "Software\\KJ\\if_alice";
		static const char *spiRegEntry[]	= {"bgColor", "flags"};
		enum REG_ENTRY
		{
			KEY_BG_COLOR,
			KEY_FLAGS
		};
		enum FLAGS
		{
			FLAG_IS_ALPHA_BREND	= 1
		};

	// WXgǂ/
		HKEY hKey;		
		if (bRead)
		{
			if (ERROR_SUCCESS != ::RegOpenKeyEx(HKEY_CURRENT_USER, spiDirKey, 0, KEY_QUERY_VALUE, &hKey))
				return;

			DWORD dwData, dwSize	= 4;
			if (ERROR_SUCCESS == ::RegQueryValueEx(hKey, spiRegEntry[KEY_BG_COLOR], NULL, NULL, (BYTE*)&dwData, &dwSize))
				m_rgb	= CRgb((COLORREF)dwData);
			if (ERROR_SUCCESS == ::RegQueryValueEx(hKey, spiRegEntry[KEY_FLAGS], NULL, NULL, (BYTE*)&dwData, &dwSize))
				m_bAlphaBrend	= dwData & FLAG_IS_ALPHA_BREND;
		} else {
			if (ERROR_SUCCESS != ::RegCreateKeyEx(HKEY_CURRENT_USER, spiDirKey, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKey, NULL))
				return;

			DWORD dwData	= (COLORREF)CRgb(m_rgb);
			::RegSetValueEx(hKey, spiRegEntry[KEY_BG_COLOR], 0, REG_DWORD, (BYTE*)&dwData, sizeof(DWORD));
			dwData	= m_bAlphaBrend ? 1 : 0;
			::RegSetValueEx(hKey, spiRegEntry[KEY_FLAGS], 0, REG_DWORD, (BYTE*)&dwData, sizeof(DWORD));
		}
		::RegCloseKey(hKey);
	}
};

// O[oɃCX^X𐶐Ȃ̂ŁA
// ƃgbL[ȂƂ܂
#define _config SpiConfig::GetConfig()
// extern SpiConfig _config;



/// ݒ_CAO
class SpiConfigDlg : public CDialogImplBase<SpiConfigDlg>
{
private:
	HBRUSH m_hBgBrush;
	COLORREF m_tmpBgColor;

public:
	enum ID { IDD = IDD_SPI_CONFIG };

	/// _CAOvV[W
	INT_PTR DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
	{
		switch(uMsg)
		{
		case WM_INITDIALOG:
		{
			m_tmpBgColor	= CRgb(_config.m_rgb);
			m_hBgBrush	= CreateSolidBrush(m_tmpBgColor);

			if (_config.m_bAlphaBrend)
				CheckDlgButton(hwndDlg, IDC_CHK_ALPHA, BST_CHECKED);
			break;
		}
		case WM_CTLCOLORSTATIC:
		{
			// wiF̐ݒ
			int nID = GetDlgCtrlID((HWND)lParam); //Rg[̂hc擾
			if (nID == IDC_STATIC_BG_COLOR)
			{				
				return (LRESULT)m_hBgBrush;
			}
			return 0;
		}
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
			case IDC_BTN_BG_COLOR:
			{
			// wiF̑I
				COLORREF custumColor[16];	// _f[^
				CHOOSECOLOR cc	= {0};
				cc.lStructSize	= sizeof(CHOOSECOLOR);
				cc.Flags		= CC_RGBINIT;// | CC_PREVENTFULLOPEN ;
				cc.lpCustColors	= custumColor;
				cc.rgbResult	= m_tmpBgColor;
				cc.hwndOwner	= hwndDlg;

				if (ChooseColor(&cc))
				{
					// uV̍쐬Aĕ`
					HBRUSH hBrush	= ::CreateSolidBrush(cc.rgbResult);
					if (hBrush != NULL)
					{
						if (m_hBgBrush != NULL)
							::DeleteObject(m_hBgBrush);
						m_hBgBrush	= hBrush;
						m_tmpBgColor	= cc.rgbResult;
						InvalidateRect(hwndDlg, NULL, 0);
					}
				}		
				break;
			}
			case IDOK:
			{
			// ݒۑ
				_config.m_bAlphaBrend	= BST_CHECKED == IsDlgButtonChecked(hwndDlg, IDC_CHK_ALPHA);
				_config.m_rgb	= CRgb(m_tmpBgColor);

				_config.UpdateRegKey(false);
			}
			case IDCANCEL:
				DeleteObject(m_hBgBrush);	// 쐬uVj
				EndDialog(hwndDlg, LOWORD(wParam));
				break;
			default:
				return 0;
			}
		default:
			return 0;
		}
		return 1;
	}
};

#endif	// SPI_CONFIG